import { PrimaryGeneratedColumn, Column, OneToMany, Entity } from "typeorm";
import {
  IsInt,
  IsNotEmpty,
  IsOptional,
  IsString,
} from "class-validator";

/**
 * Defines the Permission interface.
*/
@Entity()
export abstract class Permission {
  /**
   * Autogenerated unique id (primary key).
   */
  @PrimaryGeneratedColumn()
  @IsOptional()
  @IsInt()
  id: number;

  /**
   * The target
   */
  @Column()
  @IsNotEmpty()
  @IsString()
  target: string;

  /**
   * The action type
   */
  @Column()
  @IsNotEmpty()
  @IsString()
  action: string;
}